//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

RWStructuredBuffer<float3> Output : BACKBUFFER;

float3 R;
[numthreads(1, 1, 1)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + tid.y * R.x + tid.z * (R.y * R.x);
	
	//Output[idx] = float3(idx % R.x, idx % R.x * R.y, idx % R.x * R.y * R.z);
	Output[idx] = float3(idx % R.x, floor(idx / R.x) % R.y, floor(idx / (R.x * R.y)));
}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




